#include <iostream>
#include <iomanip>
#include <cstring>
#include <bitset>

using namespace std;

struct Student {
    char name[17];
    uint16_t admissionYear;
    float averageGrade;
    bool isMale : 1;
    uint8_t completedCourses;
    Student* groupLeader;
};

int main() {
    const int numberOfStudents = 3;
    Student students[numberOfStudents];

    students[0].admissionYear = 2023;
    students[0].averageGrade = 4.5;
    students[0].isMale = true;
    students[0].completedCourses = 5;
    students[0].groupLeader = nullptr;

    students[1].admissionYear = 2022;
    students[1].averageGrade = 3.8;
    students[1].isMale = false;
    students[1].completedCourses = 6;
    students[1].groupLeader = &students[0];

    students[2].admissionYear = 2021;
    students[2].averageGrade = 3.2;
    students[2].isMale = true;
    students[2].completedCourses = 7;
    students[2].groupLeader = nullptr;

    for (int i = 0; i < numberOfStudents; ++i) {
        cout << "\n   " << i + 1 << ":\n";
        cout << "  admissionYear: " << static_cast<void*>(&students[i].admissionYear) << ", : "
             << offsetof(Student, admissionYear) << ", : " << sizeof(students[i].admissionYear) << " , "
             << ": " << hex << students[i].admissionYear << ", : "
             << bitset<16>(students[i].admissionYear) << '\n';

        cout << "  averageGrade: " << static_cast<void*>(&students[i].averageGrade) << ", : "
             << offsetof(Student, averageGrade) << ", : " << sizeof(students[i].averageGrade) << " , "
             << ": " << students[i].averageGrade << '\n';

        cout << "    isMale: " << static_cast<void*>(&students[i].isMale) << ", : "
             << offsetof(Student, isMale) << ", : " << sizeof(students[i].isMale) << " , "
             << ": " << (students[i].isMale ? "" : "") << '\n';

        cout << "  completedCourses: " << static_cast<void*>(&students[i].completedCourses) << ", : "
             << offsetof(Student, completedCourses) << ", : " << sizeof(students[i].completedCourses) << " , "
             << ": " << static_cast<int>(students[i].completedCourses) << '\n';

        cout << "  groupLeader: " << static_cast<void*>(&students[i].groupLeader) << ", : "
             << offsetof(Student, groupLeader) << ", : " << sizeof(students[i].groupLeader) << " , "
             << ": " << hex << reinterpret_cast<uintptr_t>(students[i].groupLeader) << '\n';

        //     
        cout << "   (  ):\n";
        const uint8_t* bytes = reinterpret_cast<const uint8_t*>(&students[i]);
        for (size_t j = 0; j < sizeof(Student); ++j) {
            cout << hex << setfill('0') << setw(2) << static_cast<int>(bytes[j]) << ' ';
        }
        cout << '\n';
    }

    return 0;
}
